
//+------------------------------------------------------------------+
//|                                               ps.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGIC  20050611

extern double  Lots               = 0.1;
extern double  LimitLots          =1;

extern double            =1440;
extern int     MinutesOpen        =1;
extern int     Filter             =50;
extern double  stop_loss          = 1000;   
extern double  take_profit        = 500;
extern double  TimeClose          =16;

extern double    Coeff=2;

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimizedBUY()
{
   if (GlobalVariableCheck("REZ_BUY"+MAGIC+Symbol())==true)
   {
      OrderSelect(GlobalVariableGet("REZ_BUY"+MAGIC+Symbol()),SELECT_BY_TICKET,MODE_HISTORY);
      if (OrderProfit()>=0) return(Lots);
      else 
      {
         if (OrderProfit()<0) 
         {
            if (OrderLots()*Coeff<MarketInfo(Symbol(),MODE_MAXLOT))
            {
               if(NormalizeDouble(OrderLots()*Coeff,2)<LimitLots)
               return(NormalizeDouble(OrderLots()*Coeff,2));
               else
               return(Lots);
            }
            else
            {
               return(MarketInfo(Symbol(),MODE_MAXLOT));
            }
         }
      }
   }
   else return(Lots);
}
double LotsOptimizedSELL()
{
   if (GlobalVariableCheck("REZ_SELL"+MAGIC+Symbol())==true)
   {
      OrderSelect(GlobalVariableGet("REZ_SELL"+MAGIC+Symbol()),SELECT_BY_TICKET,MODE_HISTORY);
      if (OrderProfit()>=0) return(Lots);
      else 
      {
         if (OrderProfit()<0) 
         {
            if (OrderLots()*Coeff<MarketInfo(Symbol(),MODE_MAXLOT))
            {
               if(NormalizeDouble(OrderLots()*Coeff,2)<LimitLots)
               return(NormalizeDouble(OrderLots()*Coeff,2));
               else
               return(Lots);
            }
            else
            {
               return(MarketInfo(Symbol(),MODE_MAXLOT));
            }
         }
      }
   }
   else return(Lots);
}
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   
   datetime opentime=iTime(NULL,,0);
   
   datetime endopentime=opentime+MinutesOpen*60;
   if(TimeCurrent()>endopentime)return(0);
   else Print(" ");
 
   double OD1=iOpen(NULL,,1);
   double CD1=iClose(NULL,,1);
   int    res;
  
//---- sell conditions
   
   if((OD1-CD1)>Filter*Point&&OrdersTotal()<1)  
     {
      res=OrderSend(Symbol(),OP_SELL,LotsOptimizedSELL(),Bid,3,Bid + stop_loss * Point,Ask - take_profit * Point,"",MAGIC,0,Red);
     
      GlobalVariableSet("REZ_SELL"+MAGIC+Symbol(),res);
      return;
     }
//---- buy conditions
   
   if((CD1-OD1)>Filter*Point&&OrdersTotal()<1)
     {
      res=OrderSend(Symbol(),OP_BUY,LotsOptimizedBUY(),Ask,3,Ask - stop_loss * Point,Bid + take_profit * Point,"",MAGIC,0,Blue);
     
      GlobalVariableSet("REZ_BUY"+MAGIC+Symbol(),res);
      return;
     }
//----
  }
        

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {

 CheckForOpen();
 CheckForClose();
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+


void CheckForClose()
  {
 

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if( OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(Hour()>=TimeClose ) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(Hour()>=TimeClose) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }
//----
  }
 